﻿Imports Nevron.GraphicsCore
Imports Nevron.Chart
Imports Nevron.Chart.WinForm
Imports System.Drawing
Imports Nevron

Public Class RadialMeter

    Dim indicator As New NNeedleValueIndicator
    Dim radialGauge As NRadialGaugePanel
    Dim backgroundPanel As NBackgroundDecoratorPanel
    Dim MaxValue As Double
    Dim Range As Dictionary(Of Double, Color)


    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.
    End Sub

    Private Sub RadialMeter_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    End Sub

    Public Sub InitializeChart(ByVal Caption As String, ByVal MaxValue As Double, ByVal Range As Dictionary(Of Double, Color))

        Me.MaxValue = MaxValue
        Me.Range = Range

        mChart.BackgroundStyle = New NBackgroundStyle
        mChart.BackgroundStyle.FillStyle = New NGradientFillStyle(Color.White, Color.FromArgb(229, 248, 245))
        mChart.BackgroundStyle.FrameStyle.Visible = False

        ' create the radial gauge
        radialGauge = New NRadialGaugePanel()
        radialGauge.Dock = DockStyle.Fill
        radialGauge.DockMargins = New NMarginsL(8, 10, 8, 0)
        radialGauge.BackgroundFillStyle = New NGradientFillStyle(Color.White, Color.White)
        radialGauge.BorderStyle = Nothing 'New NEdgeBorderStyle(BorderShape.RoundedRect)
        radialGauge.CapStyle.Visible = False
        radialGauge.PositionChildPanelsInContentBounds = True

        radialGauge.BeginAngle = -180
        radialGauge.SweepAngle = 180

        Dim axis As NGaugeAxis = CType(radialGauge.Axes(0), NGaugeAxis)
        axis.Range = New NRange1DD(0, MaxValue)

        Dim scale As NLinearScaleConfigurator = CType(axis.ScaleConfigurator, NLinearScaleConfigurator)
        scale.AutoLabels = False
        'scale.RulerStyle.FillStyle = New NColorFillStyle(Helper.MediumBlue)
        'scale.RulerStyle.BorderStyle.Color = Helper.MediumBlue

        backgroundPanel = New NBackgroundDecoratorPanel()
        backgroundPanel.Dock = DockStyle.Fill
        backgroundPanel.BackgroundStyle.FillStyle = New NGradientFillStyle(Color.White, Color.White)
        backgroundPanel.BorderStyle = Nothing

        backgroundPanel.ChildPanels.Add(radialGauge)
        mChart.Panels.Add(backgroundPanel)
        mChart.BackgroundStyle.FillStyle = New NColorFillStyle(Color.White)

        'RiskChart.Panels.Add(radialGauge)

    End Sub

    Public Sub SetValue(ByVal Caption As String, ByVal Value As Double)
        'm_NumericDisplay.DockMargins = New NMarginsL(0, 0, 0, 0)
        'm_NumericDisplay.Padding = New NMarginsL(0, 0, 100, 100)

        Dim fillColor As Color = Color.Tomato
        Dim lBound As Double = 0
        For Each Key As Double In Me.Range.Keys
            If Value > lBound And Value <= Key Then
                fillColor = Me.Range(Key)
                Exit For
            Else
                lBound = Key
            End If
        Next

        lblValue.Text = Value
        lblCaption.Text = Caption
        lblCaption.ForeColor = fillColor

        radialGauge.Indicators.Clear()

        Dim rangeIndicator As NRangeIndicator = New NRangeIndicator(New NRange1DD(0, 10))

        rangeIndicator.StrokeStyle.Width = New NLength(10)
        rangeIndicator.BeginWidth = New NLength(10)
        rangeIndicator.EndWidth = New NLength(10)
        rangeIndicator.OffsetFromScale = New NLength(0)

        rangeIndicator.StrokeStyle.Color = fillColor

        rangeIndicator.PaintOrder = IndicatorPaintOrder.AfterChildPanels

        radialGauge.Indicators.Add(rangeIndicator)

        indicator.Shape.FillStyle = New NColorFillStyle(Color.Gray)
        indicator.Shape.StrokeStyle.Color = Color.Gray

        radialGauge.Indicators.Add(indicator)
        indicator.Value = Value


        mChart.Refresh()

    End Sub


End Class

